vr_prepare_first = nil
vr_prepare = nil
vr_prep_assault_check = nil
vr_ini_10s = nil
vr_ini_20s = nil
vr_10s = nil
vr_20s = nil
vr_assault = nil
vr_break = nil
vr_stop = nil
local mercurius_modifier
local ban_toggle = CanaryOptions._data.ban_toggle
if RequiredScript == 'lib/managers/hudmanager' then

function HUDManager:sync_start_anticipation_music()
	managers.music:post_event(tweak_data.levels:get_music_event("anticipation"))
	local current_map = managers.job:current_level_id()
	if current_map ~= "watchdogs_1_night" then
		if current_map ~= "watchdogs_1" then
		if current_map ~= "alex_1" then
		if current_map ~= "firestarter_1" then
		if not vr_prepare_first then
			if not vr_ini_10s and not vr_ini_20s then
				DelayedCalls:Add("anticipation_ini_10", 20, vr_10s_i)
				vr_ini_10s = true
				DelayedCalls:Add("anticipation_ini_20", 10, vr_20s_i)
				vr_ini_20s = true
				if Utils:IsInCustody() ~= true then
				managers.player:local_player():sound():say( 'Play_ban_b01b', false, ban_toggle )
				DelayedCalls:Add("30sconfirm", 5, assault_30s)
				end
			vr_prepare_first = true
			end
		end
		elseif current_map == "firestarter_1" then
			if not vr_prepare_first then
				if not vr_ini_10s and vr_ini_20s then
					DelayedCalls:Add("anticipation_ini_10", 20, vr_10s_i)
					vr_ini_10s = true
					DelayedCalls:Add("anticipation_aft_20", 10, vr_20s_f)
					vr_ini_20s = true
				vr_prepare_first = true
				end
			end
		end
		elseif current_map == "alex_1" then
			if not vr_prepare_first then
				if not vr_ini_10s and vr_ini_20s then
					DelayedCalls:Add("anticipation_ini_10", 20, vr_10s_i)
					vr_ini_10s = true
					DelayedCalls:Add("anticipation_aft_20", 10, vr_20s_f)
					vr_ini_20s = true
				vr_prepare_first = true
				end
			end
		end
		if not vr_prepare and vr_prepare_first and vr_prep_assault_check then
		local vr_prep_random = { 'Play_ban_b03x', 'Play_ban_b04x', 'Play_ban_b05x' }
		local vr_prep_random_a = vr_prep_random[math.random( #vr_prep_random )]
			if ( vr_prep_random_a == 'Play_ban_b04x' ) and not vr_20s then
				DelayedCalls:Add("anticipation_aft_20", 10, vr_20s_f)
				DelayedCalls:Add("anticipation_ini_10", 20, vr_10s_i)
				vr_20s = true
			elseif ( vr_prep_random_a == 'Play_ban_b05x' ) and not vr_10s then
				DelayedCalls:Add("anticipation_aft_10", 20, vr_10s_f)
				vr_10s = true
			elseif ( vr_prep_random_a == 'Play_ban_b03x' ) then
				if Utils:IsInCustody() ~= true then
				managers.player:local_player():sound():say( 'Play_ban_b03x', false, ban_toggle )
				DelayedCalls:Add("30sconfirm", 5, assault_30s)
				end
				DelayedCalls:Add("anticipation_ini_20", 10, vr_20s_i)
				DelayedCalls:Add("anticipation_ini_10", 20, vr_10s_i)
			end
		end
		end
	end
end

elseif RequiredScript == 'lib/managers/hudmanagerpd2' then

function HUDManager:sync_start_assault(data)
	managers.music:post_event(tweak_data.levels:get_music_event("assault"))
	local assault_diag = {
		"gen_ban_b02c",
		"Play_ban_s05"
	}
	local assault_rand = assault_diag[math.random( #assault_diag )]
	if ( assault_rand == "gen_ban_b02c" ) then
		if not managers.groupai:state():get_hunt_mode() then		
			managers.dialog:queue_dialog("gen_ban_b02c", {})
		end
	elseif ( assault_rand == "Play_ban_s05" ) then
		if not managers.groupai:state():get_hunt_mode() then
			DelayedCalls:Add("specials_incoming", 0.5, vr_inbound)
		end
	end
	self._hud_assault_corner:sync_start_assault(data)
	vr_prepare_first = true
	vr_prep_assault_check = true
	vr_prepare = nil
	vr_20s = nil
	vr_10s = nil
	vr_break = nil
	vr_stop = nil
	if not vr_assault then
	if Utils:IsInGameState() and Utils:IsInCustody() ~= true then
		DelayedCalls:Add("letsrock", 0.1, vr_letsrock)
		DelayedCalls:Add("warcry_rep", 0.1, vr_warcry_rep)
		vr_noreturn = nil
		vr_assault = true
		vr_break = nil
		vr_emergency = nil
		if not Utils:IsInGameState() then
		if DLCManager_hasdlcpack(bonnie) then
		mercurius_exec()
		end
		end
	end
	end
end

function HUDManager:sync_end_assault(result)
	managers.music:post_event(tweak_data.levels:get_music_event("control"))
	local result_diag = {
		"gen_ban_b12",
		"gen_ban_b11",
		"gen_ban_b10"
	}
	if result then
		managers.dialog:queue_dialog(result_diag[result + 1], {})
	end
	self._hud_assault_corner:sync_end_assault(result)
	vr_assault = nil
	if not vr_break and Utils:IsInCustody() ~= true then
		managers.player:local_player():sound():say( 'p24', false, false )
		vr_assault = nil
		vr_noreturn = nil
		vr_break = true
		vr_emergency = nil
	end
	DelayedCalls:Remove("warcry_rep")
	DelayedCalls:Remove("warcry")
	DelayedCalls:Remove("warcry_check")
	vr_stop = true
end

end