local gas = 0

if RequiredScript == "lib/managers/dialogmanager" then

function DialogManager:canary_dialog(id)
	--Rats (Cook Off)
	if (id == "pln_rat_stage1_13" ) then
		DelayedCalls:Add("rat_forest", 1, rat_forest)
	end
	if (id == "play_pln_gen_att_11") then
		DelayedCalls:Add("rat_window", 1, rat_window)
	end
	if (id == "pln_rt1_14") then
		DelayedCalls:Add("rat_upwalls", 1, snip_climbup)
	end
	if (id == "pln_rat_stage1_14") then
		DelayedCalls:Add("snipers", 2, sniper_call)
	end
	if (id == "play_pln_gen_att_01") then
		DelayedCalls:Add("inside", 1, pl_inside)
	end
	if (id == "play_pln_gen_att_13") then
		DelayedCalls:Add("rat_stair", 1, rat_stairwell)
	end
	if (id == 'pln_rt1_05') then
		DelayedCalls:Add("rat_inside", 2.75, rat_inside)
	end
	if (id == 'pln_rt1_15') then
		DelayedCalls:Add("rat_balc", 1, rat_balcony)
	end
	if (id == 'pln_rat_stage1_27') then
		DelayedCalls:Add("timetogo", 2.5, vr_noreturn_delay)
	end
	if (id == "play_pln_gen_count_04") or (id == "Play_dr1_a16") then
		rat_check04 = true
	end
	if (id == "play_pln_gen_count_07") or (id == "Play_dr1_a20") then
		rat_check31 = true
	end
	
	--Escape (Twitch)
	if (id == "Play_dr1_a03") then
		DelayedCalls:Add("230", 30, esc_230)
	end
	if (id == "Play_dr1_a04") then
		DelayedCalls:Add("200", 2, esc_200)
	end
	if (id == "Play_dr1_a05") then
		DelayedCalls:Add("100", 2, esc_100)
	end
	if (id == "Play_dr1_a06") then
		DelayedCalls:Add("030", 2, assault_30s)
	end
	if (id == "Play_dr1_a07") then
		DelayedCalls:Add("timetogo", 2.5, vr_noreturn_delay)
	end
	
	--Escape (Bile)
	if (id == "Play_plt_a04") then
		DelayedCalls:Add("230", 30, esc_230)
	end
	if (id == "Play_plt_a05") then
		DelayedCalls:Add("200", 2, esc_200)
	end
	if (id == "Play_plt_a06") then
		DelayedCalls:Add("100", 2, esc_100)
	end
	if (id == "Play_plt_a07") then
		DelayedCalls:Add("030", 2, assault_30s)
	end
	if (id == "Play_plt_a08") then
		DelayedCalls:Add("timetogo", 2.5, vr_noreturn_delay)
	end
	
	--Shadow Raid
	if (id == "Play_pln_ko1_22") then
		DelayedCalls:Add("holyshit", 1, holyshit)
	end

	--Bank Heist
	if (id == "pln_branchbank_stage1_37") or (id == "Play_pln_hb2_18") then
		DelayedCalls:Add("tear_gas", 1, dia_bank_gas)
	end
	
	--Police
	if (id == "play_pln_gen_pol_01") or (id == "play_pln_gen_att_06") then
		DelayedCalls:Add("theres_the_police", 1, assault_20s)
	end
	if (id == "play_pln_gen_snip_01") or (id == "play_pln_gen_snip_02") then
		DelayedCalls:Add("snipers", 2, sniper_call)
	end
	if (id == "Play_pln_ukranian_stage1_25") then
		DelayedCalls:Add("theres_the_police", 2, assault_20s)
	end
	if (id == "play_pln_gen_bgst_01") then
		DelayedCalls:Add("takingbags", 1.5, stealing_bags)
	end
	
	--Police (Location)
	if (id == "play_pln_gen_att_02") then
		DelayedCalls:Add("roofs", 2, pl_roofs)
	end
	if (id == "play_pln_gen_att_08") then
		DelayedCalls:Add("outside", 2, pl_outside)
	end
	if (id == "play_pln_gen_att_10") then
		DelayedCalls:Add("down", 2, pl_down)
	end
	if (id == "play_pln_gen_snip_05") then
		DelayedCalls:Add("snipers", 3, sniper_call)
		DelayedCalls:Add("roofs", 4.5, pl_roofs)
	end
	if (id == "play_pln_gen_snip_04") then
		DelayedCalls:Add("snipers", 3, sniper_call)
		DelayedCalls:Add("snip_climbup", 4.5, snip_climbup)
	end
	if (id == "play_pln_gen_snip_03") then
		DelayedCalls:Add("snipers", 3, sniper_call)
		DelayedCalls:Add("snip_heli", 4.5, snip_heli)
	end
	
end

function DialogManager:queue_dialog(id, params)
	if not params.skip_idle_check and managers.platform:presence() == "Idle" then
		return
	end
	if not self._dialog_list[id] then
		debug_pause("The dialog script tries to queue a dialog with id '" .. tostring(id) .. "' which doesn't seem to exist!")
		return false
	end
	if not self._current_dialog then
		self._current_dialog = {id = id, params = params}
		self:_play_dialog(self._dialog_list[id], params)
	else
		local dialog = self._dialog_list[id]
		if self._next_dialog and dialog.priority > self._dialog_list[self._next_dialog.id].priority then
			self:_call_done_callback(params and params.done_cbk, "skipped")
			return false
		end
		if dialog.priority < self._dialog_list[self._current_dialog.id].priority then
			if self._next_dialog then
				self:_call_done_callback(self._dialog_list[self._next_dialog.id].params and self._dialog_list[self._next_dialog.id].params.done_cbk, "skipped")
			end
			self._next_dialog = {id = id, params = params}
		else
			self:_call_done_callback(params and params.done_cbk, "skipped")
		end
	end
	self:canary_dialog(id)
	log(id)
	return true
end
 
elseif RequiredScript == "lib/managers/hud/hudobjectives" then

if HUDRestorationExists == true then

function HUDObjectives:activate_objective( data )

	self._active_objective_id = data.id
	log(self._active_objective_id)
	local objectives_panel = self._hud_panel:child( "objectives_panel" )
	local objective_text = objectives_panel:child( "objective_text" )
	local amount_text = objectives_panel:child( "amount_text" )
	objective_text:set_text( utf8.to_upper( data.text ) )
	log( "utf8.to_upper( data.text)" )
	local _,_,w,_ = objective_text:text_rect()
	objectives_panel:child( "objectives_pad_panel" ):set_w( w + 12*2 )
	
	amount_text:set_x( objective_text:x() + 4 + w )
	objectives_panel:set_visible( true )
		
	self._bg_box:set_h( 38 )
	
	local w2 = 0
	
	amount_text:set_visible( false )
	if data.amount then
		self:update_amount_objective( data )
		local _, _, wide, _ = amount_text:text_rect()
		w2 = wide + 4
	end
		
	objective_text:set_visible( false )
	self._bg_box:stop()
	self._bg_box:animate( callback( nil, _G, "HUDBGBox_animate_open_right" ), 0.66, w + 8*2 + w2 + 8, callback( self, self, "open_right_done", data.amount and true or false ) )
	
	objectives_panel:stop()
	objectives_panel:animate( callback( self, self, "_animate_activate_objective" ) )
	
end


function HUDObjectives:update_amount_objective( data )
	if data.id ~= self._active_objective_id then
		return
	end
		
	local current = data.current_amount or 0
	objective_current_amount_override = data.current_amount
	local amount = data.amount
	objective_amount_override = data.amount
	
	local objectives_panel = self._hud_panel:child( "objectives_panel" )
	-- objectives_panel:child( "amount_panel" ):child( "amount_text" ):set_text( current.."/"..amount)
	objectives_panel:child( "amount_text" ):set_text( current.."/"..amount)
end

elseif HUDRestorationExists == false then

function HUDObjectives:activate_objective(data)
	self._active_objective_id = data.id
	log(self._active_objective_id)
	local objectives_panel = self._hud_panel:child("objectives_panel")
	local objective_text = objectives_panel:child("objective_text")
	objective_text:set_text(utf8.to_upper(data.text))
	log( utf8.to_upper( data.text) )
	local _, _, w, _ = objective_text:text_rect()
	objectives_panel:set_visible(true)
	self._bg_box:set_h(data.amount and 60 or 38)
	objective_text:set_visible(false)
	self._bg_box:stop()
	self._bg_box:animate(callback(nil, _G, "HUDBGBox_animate_open_right"), 0.66, w + 16, callback(self, self, "open_right_done", data.amount and true or false))
	objectives_panel:stop()
	objectives_panel:animate(callback(self, self, "_animate_activate_objective"))
	objectives_panel:child("amount_text"):set_visible(false)
	if data.amount then
		self:update_amount_objective(data)
	end
end

function HUDObjectives:update_amount_objective(data)
	if data.id ~= self._active_objective_id then
		return
	end
	local current = data.current_amount or 0
	objective_current_amount_override = data.current_amount
	local amount = data.amount
	objective_amount_override = data.amount
	local objectives_panel = self._hud_panel:child("objectives_panel")
	objectives_panel:child("amount_text"):set_text(current .. "/" .. amount)
end

end
end