vr_flashbang_check = nil
cableties_first = nil
vr_cam_notifier_1 = nil
vr_camera_count = 0
vr_fetch_count = nil
vr_said_hurt = nil
vr_fixmeup = nil
letsrock = 0
cam_half = false
cam_gone = false
local Net = _G.LuaNetworking
local ban_global = CanaryOptions._data.ban_global
local ban_toggle = CanaryOptions._data.ban_toggle
local ban_pag_toggle = CanaryOptions._data.ban_pag_toggle
local ply_knees = CanaryOptions._data.ply_knees_toggle
local ply_cams = CanaryOptions._data.ply_cams_toggle
local server_synchronized
local cloaker_count = 0
local shd_count = 0
local bdz_count = 0
local tsr_count = 0
local vr_cloaker


-- Pagers
if RequiredScript == 'lib/managers/group_ai_states/groupaistatebase' then
function GroupAIStateBase:on_successful_alarm_pager_bluff()
	self._nr_successful_alarm_pager_bluffs = self._nr_successful_alarm_pager_bluffs + 1
	
	PagerCount = self._nr_successful_alarm_pager_bluffs
	
	if ban_pag_toggle == true then
		if PagerCount < 3 then
			DelayedCalls:Add("v_pager_success", 2, vr_p_success)
		elseif PagerCount == 3 then
			DelayedCalls:Add("v_pager_suspicious", 2, vr_p_suspicious)
		elseif PagerCount == 4 then
			DelayedCalls:Add("v_pager_warning", 4, vr_p_warning)
		elseif PagerCount == 5 then
			DelayedCalls:Add("v_pager_failed", 1, vr_p_failed)
		end
	elseif ban_pag_toggle ~= true then
		local PagerRoll = math.random(1,100)
		if PagerCount == 1 then
			if PagerRoll == 1 then
				DelayedCalls:Add("v_pager_success", 2, vr_p_success)
			end
		elseif PagerCount == 2 then
			if PagerRoll <= 10 then
				DelayedCalls:Add("v_pager_success", 2, vr_p_success)
			end
		elseif PagerCount == 3 then
			if PagerRoll <= 50 then
				DelayedCalls:Add("v_pager_success", 2, vr_p_success)
			end
		elseif PagerCount == 4 then
			DelayedCalls:Add("v_pager_suspicious", 2, vr_p_suspicious)
		elseif PagerCount == 5 then
			DelayedCalls:Add("v_pager_failed", 1, vr_p_failed)
		end
	end
		
	if Net:IsMultiplayer() and Net:IsHost() then
	if ban_toggle ~= true then
	log("pager_sent_to_peers")
		Net:SendToPeers( "C_PagerStatus", PagerCount )
	end
	end
	
end
function GroupAIStateBase:sync_event(event_id, blame_id)
	local event_name = self.EVENT_SYNC[event_id]
	local blame_name = self.BLAME_SYNC[blame_id]
	if event_name == "police_called" then
		self._police_called = true
		self:_call_listeners("police_called")
	elseif event_name == "enemy_weapons_hot" then
		self._police_called = true
		self._enemy_weapons_hot = true
		managers.music:post_event(tweak_data.levels:get_music_event("control"))
		self:_call_listeners("enemy_weapons_hot")
		managers.enemy:add_delayed_clbk("notify_bain_weapons_hot", callback(self, self, "notify_bain_weapons_hot", blame_name), Application:time() + 0)
		managers.enemy:set_corpse_disposal_enabled(true)
		managers.dialog:queue_dialog( 'play_pln_gen_bfr_10', {})
		--Net:SendToPeers( "C_Clock", '' )
	elseif event_name == "cloaker_spawned" then
		managers.hud:post_event("cloaker_spawn")
		cloaker_count = cloaker_count + 1
		if cloaker_count == 1 and not vr_cloaker then
		DelayedCalls:Add("incom_clk", 1, incoming_clk)
		end
		if cloaker_count == 4 then
		DelayedCalls:Add("incom_clk", 1, incoming_clk)
		cloaker_count = 0
		vr_cloaker = true
		end
		if cloaker_count == 3 and vr_cloaker then
		DelayedCalls:Add("incom_clk", 1, incoming_clk)
		cloaker_count = 0
		end
	end
end

function GroupAIStateBase:register_security_camera(unit, state)
	self._security_cameras[unit:key()] = state and unit or nil
	if not vr_fetch_count then
	vr_camera_count = vr_camera_count + 1
	DelayedCalls:Add("cam_upd", 3, camera_upd)
	end
end

function GroupAIStateBase:_radio_chatter_clbk()
	if self._ai_enabled and not self:get_assault_mode() then
		local optimal_dist = 500
		local best_dist, best_cop, radio_msg
		for _, c_record in pairs(self._player_criminals) do
			for i, e_key in ipairs(c_record.important_enemies) do
				local cop = self._police[e_key]
				local use_radio = cop.char_tweak.use_radio
				if use_radio then
					local dist = math.abs(mvector3.distance(cop.m_pos, c_record.m_pos))
					if not best_dist or best_dist > dist then
						best_dist = dist
						best_cop = cop
						radio_msg = use_radio
					end
				end
			end
		end
		if best_cop then
			best_cop.unit:sound():play(radio_msg, nil, true)
			log(radio_msg)
		end
	end
	self._radio_clbk = callback(self, self, "_radio_chatter_clbk")
	managers.enemy:add_delayed_clbk("_radio_chatter_clbk", self._radio_clbk, Application:time() + 30 + math.random(0, 20))
end

function GroupAIStateBase:chk_say_enemy_chatter(unit, unit_pos, chatter_type)
	if unit:sound():speaking(self._t) then
		return
	end
	local chatter_tweak = tweak_data.group_ai.enemy_chatter[chatter_type]
	local chatter_type_hist = self._enemy_chatter[chatter_type]
	if not chatter_type_hist then
		chatter_type_hist = {
			cooldown_t = 0,
			events = {}
		}
		self._enemy_chatter[chatter_type] = chatter_type_hist
	end
	local t = self._t
	if t < chatter_type_hist.cooldown_t then
		return
	end
	local nr_events_in_area = 0
	for i_event, event_data in pairs(chatter_type_hist.events) do
		if t > event_data.expire_t then
			chatter_type_hist[i_event] = nil
		elseif mvector3.distance(unit_pos, event_data.epicenter) < chatter_tweak.radius then
			if nr_events_in_area == chatter_tweak.max_nr - 1 then
				return
			else
				nr_events_in_area = nr_events_in_area + 1
			end
		end
	end
	local group_requirement = chatter_tweak.group_min
	if group_requirement and group_requirement > 1 then
		local u_data = self._police[unit:key()]
		local nr_in_group = 1
		if u_data.group then
			nr_in_group = u_data.group.size
		end
		if group_requirement > nr_in_group then
			return
		end
	end
	chatter_type_hist.cooldown_t = t + math.lerp(chatter_tweak.interval[1], chatter_tweak.interval[2], math.random())
	local new_event = {
		epicenter = mvector3.copy(unit_pos),
		expire_t = t + math.lerp(chatter_tweak.duration[1], chatter_tweak.duration[2], math.random())
	}
	table.insert(chatter_type_hist.events, new_event)
	unit:sound():say(chatter_tweak.queue, true)
	--log(chatter_tweak.queue)
	if chatter_tweak.queue == "shd" then
		shd_count = shd_count + 1
		if shd_count == 1 and not vr_shield then
		DelayedCalls:Add("incom_shd", 2, incoming_shd)
		end
		if shd_count == 4 then
			local value = math.random(1,2)
			if value == 1 then
			DelayedCalls:Add("incom_shd", 2, incoming_shd_g)
			elseif value == 2 then
			DelayedCalls:Add("incom_shd", 2, incoming_shd)
			end
		shd_count = 0
		vr_shield = true
		end
		if shd_count == 3 and vr_shield then
		DelayedCalls:Add("incom_shd", 2, incoming_shd)
		shd_count = 0
		end
	elseif chatter_tweak.queue == "tsr" then
		tsr_count = tsr_count + 1
		if tsr_count == 1 and not vr_taser then
		DelayedCalls:Add("incom_tsr", 2, incoming_tsr)
		end
		if tsr_count == 4 then
			local value = math.random(1,2)
			if value == 1 then
			DelayedCalls:Add("incom_tsr", 2, incoming_tsr_g)
			elseif value == 2 then
			DelayedCalls:Add("incom_tsr", 2, incoming_tsr)
			end
		tsr_count = 0
		vr_taser = true
		end
		if tsr_count == 3 and vr_taser then
		DelayedCalls:Add("incom_tsr", 2, incoming_tsr)
		tsr_count = 0
		end
	elseif chatter_tweak.queue == "bdz" then
		bdz_count = bdz_count + 1
		if bdz_count == 1 and not vr_dozer then
		DelayedCalls:Add("incom_bdz", 2, incoming_bdz)
		end
		if bdz_count == 4 then
			local value = math.random(1,2)
			if value == 1 then
			DelayedCalls:Add("incom_bdz", 2, incoming_bdz_g)
			elseif value == 2 then
			DelayedCalls:Add("incom_bdz", 2, incoming_bdz)
			end
		bdz_count = 0
		vr_dozer = true
		end
		if bdz_count == 3 and vr_dozer then
		DelayedCalls:Add("incom_bdz", 2, incoming_bdz)
		bdz_count = 0
		end
	end
	
	return true
end

elseif RequiredScript == 'lib/managers/mission/elementsecuritycamera' then
function ElementSecurityCamera:on_destroyed()
	if not self._values.enabled then
		return
	end
	self._values.destroyed = true
	self:check_triggers("destroyed")
	vr_camera_count = vr_camera_count - 1
	if ( vr_camera_count <= vr_camera_halfway ) and not cam_half and not cam_gone then
		if Utils:IsInCustody() ~= true then
		if not ban_global then
		managers.player:local_player():sound():say( 'Play_ban_v02x', false, ban_toggle )
		end
		if ban_toggle ~= true then
		Net:SendToPeers( "C_CamHalf", "" )
		end
		end
		cam_half = true
	end
	if ( vr_camera_count == 0 ) and not cam_gone then
		if Utils:IsInCustody() ~= true then
		if not ban_global then
		managers.player:local_player():sound():say( 'Play_ban_v03x', false, ban_toggle )
		end
		if ban_toggle ~= true then
		Net:SendToPeers( "C_CamGone", "" )
		end
		end
		cam_gone = true
	end
end

elseif RequiredScript == 'lib/units/interactions/interactionext' then

function IntimitateInteractionExt:_at_interact_interupt(player, complete)
	IntimitateInteractionExt.super._at_interact_interupt(self, player, complete)
	if self.tweak_data == "corpse_alarm_pager" then
		if not self._in_progress then
			return
		end
		player:sound():say("dsp_stop_all", false, true)
		if not complete then
			self._unit:base():set_material_state(true)
			if Network:is_server() then
				self._nbr_interactions = self._nbr_interactions - 1
				if self._nbr_interactions == 0 then
					self._in_progress = nil
					self._unit:brain():on_alarm_pager_interaction("interrupted", player)
					DelayedCalls:Add("v_pager_broken", 2, vr_p_break)
				end
			else
				self._in_progress = nil
				if managers.enemy:get_corpse_unit_data_from_key(self._unit:key()) then
					local u_id = managers.enemy:get_corpse_unit_data_from_key(self._unit:key()).u_id
					managers.network:session():send_to_host("alarm_pager_interaction", u_id, self.tweak_data, 2)
					DelayedCalls:Add("v_pager_broken", 2, vr_p_break)
				else
					managers.network:session():send_to_host("sync_interacted", self._unit, self._unit:id(), self.tweak_data, 2)
				end
			end
		end
	end
end
elseif RequiredScript == 'lib/units/enemies/cop/copbrain' then
function CopBrain:clbk_alarm_pager(ignore_this, data)
	local pager_data = self._alarm_pager_data
	local clbk_id = pager_data.pager_clbk_id
	pager_data.pager_clbk_id = nil
	if not managers.groupai:state():whisper_mode() then
		self:end_alarm_pager()
		return
	end
	if pager_data.nr_calls_made == 0 then
		if managers.groupai:state():is_ecm_jammer_active("pager") then
			self:end_alarm_pager()
			self:begin_alarm_pager(true)
			return
		end
		self._unit:sound():stop()
		if self._unit:character_damage():dead() then
			self._unit:sound():corpse_play("dsp_radio_query_1", nil, true)
			DelayedCalls:Add("v_pager_notify", 0.25, vr_p_notify)
		else
			self._unit:sound():play("dsp_radio_query_1", nil, true)
			DelayedCalls:Add("v_pager_notify", 0.25, vr_p_notify)
		end
		self._unit:interaction():set_tweak_data("corpse_alarm_pager")
		self._unit:interaction():set_active(true, true)
	elseif pager_data.nr_calls_made < pager_data.total_nr_calls then
		self._unit:sound():stop()
		if self._unit:character_damage():dead() then
			self._unit:sound():corpse_play("dsp_radio_reminder_1", nil, true)
		else
			self._unit:sound():play("dsp_radio_reminder_1", nil, true)
		end
	elseif pager_data.nr_calls_made == pager_data.total_nr_calls then
		self._unit:interaction():set_active(false, true)
		managers.groupai:state():on_police_called("alarm_pager_not_answered")
		self._unit:sound():stop()
		if self._unit:character_damage():dead() then
		DelayedCalls:Add("v_pager_missed", 0, vr_p_missed)
		else
		DelayedCalls:Add("v_pager_missed", 0, vr_p_missed)
		end
		self:end_alarm_pager()
	end
	if pager_data.nr_calls_made == pager_data.total_nr_calls - 1 then
		self._unit:interaction():set_outline_flash_state(true, true)
	end
	pager_data.nr_calls_made = pager_data.nr_calls_made + 1
	if pager_data.nr_calls_made <= pager_data.total_nr_calls then
		local duration_settings = tweak_data.player.alarm_pager.call_duration[math.min(#tweak_data.player.alarm_pager.call_duration, pager_data.nr_calls_made)]
		local call_delay = math.lerp(duration_settings[1], duration_settings[2], math.random())
		self._alarm_pager_data.pager_clbk_id = clbk_id
		managers.enemy:add_delayed_clbk(self._alarm_pager_data.pager_clbk_id, callback(self, self, "clbk_alarm_pager"), TimerManager:game():time() + call_delay)
	end
end

-- Security Cameras
elseif RequiredScript == 'lib/units/props/securitycamera' then
local vr_camera_robber

function SecurityCamera:_sound_the_alarm(detected_unit)
local current_map = managers.job:current_level_id()
	if self._alarm_sound then
		return
	end
	if Network:is_server() then
		if self._mission_script_element then
			self._mission_script_element:on_alarm(self._unit)
		end
		self:_send_net_event(self._NET_EVENTS.alarm_start)
		self._call_police_clbk_id = "cam_call_cops" .. tostring(self._unit:key())
		managers.enemy:add_delayed_clbk(self._call_police_clbk_id, callback(self, self, "clbk_call_the_police"), Application:time() + 7)
		local reason_called = managers.groupai:state().analyse_giveaway("security_camera", detected_unit)
		self._reason_called = managers.groupai:state():fetch_highest_giveaway(self._reason_called, reason_called)
		self:_destroy_all_detected_attention_object_data()
		self:set_detection_enabled(false, nil, nil)
	end
	if self._suspicion_sound then
		self._suspicion_sound = nil
		self._unit:sound_source():post_event("camera_suspicious_signal_stop")
	end
	self._alarm_sound = self._unit:sound_source():post_event("camera_alarm_signal")
	if not vr_camera_robber and current_map ~= "firestarter_1" then
	DelayedCalls:Add("suspicious_camera_warning", 2, vr_c_suspicious)
	DelayedCalls:Add("suspicious_camera_alerted", 5, vr_c_alert)
	vr_camera_robber = true
	end
end

--Security Camera Interaction
elseif RequiredScript == 'lib/units/beings/player/states/playerstandard' then

function PlayerStandard:_start_action_intimidate(t)
local vr_character = managers.criminals:local_character_name()
	if not self._intimidate_t or t - self._intimidate_t > tweak_data.player.movement_state.interaction_delay then
		local skip_alert = managers.groupai:state():whisper_mode()
		local voice_type, plural, prime_target = self:_get_unit_intimidation_action(true, true, true, false, true, nil, nil, nil)
		local interact_type, sound_name
		local sound_suffix = plural and "plu" or "sin"
		local down_old = "f02x_" .. sound_suffix
		local down_table = { down_old, "l02x_sin" }
		local down_random = down_table[math.random( #down_table )]
		local cameras_table = { 'f39_any', 'g25' }
		local cameras_random = cameras_table[math.random( #cameras_table )]
		local mark_table = { "g15", "g10" }
		local mark_random = mark_table[math.random( #mark_table )]
		if voice_type == "stop" then
			interact_type = "cmd_stop"
			sound_name = "f02x_" .. sound_suffix
		elseif voice_type == "stop_cop" then
			interact_type = "cmd_stop"
			sound_name = "l01x_" .. sound_suffix
		elseif voice_type == "mark_cop" or voice_type == "mark_cop_quiet" then
			interact_type = "cmd_point"
			if voice_type == "mark_cop_quiet" then
			local mark_old = tweak_data.character[prime_target.unit:base()._tweak_table].silent_priority_shout .. '_any'
			local mark_table_2 = { "g15", "g10", mark_old }
			local mark_random_2 = mark_table_2[math.random( #mark_table_2 )]
				if vr_character == 'american' then
				sound_name = mark_random
				elseif (vr_character == 'old_hoxton') or (vr_character == 'female_1') then
				sound_name = tweak_data.character[prime_target.unit:base()._tweak_table].silent_priority_shout .. '_any'
				else
				sound_name = mark_random_2
				end
			else
				sound_name = tweak_data.character[prime_target.unit:base()._tweak_table].priority_shout .. "x_any"
			end
			if managers.player:has_category_upgrade("player", "special_enemy_highlight") then
				prime_target.unit:contour():add(managers.player:has_category_upgrade("player", "marked_enemy_extra_damage") and "mark_enemy_damage_bonus" or "mark_enemy", true, managers.player:upgrade_value("player", "mark_enemy_time_multiplier", 1))
			end
		elseif voice_type == "down" then
			interact_type = "cmd_down"
			if ply_knees then
			sound_name = down_random
			else
			sound_name = "f02x_" .. sound_suffix
			end
			self._shout_down_t = t
		elseif voice_type == "down_cop" then
			interact_type = "cmd_down"
			sound_name = "l02x_" .. sound_suffix
		elseif voice_type == "cuff_cop" then
			interact_type = "cmd_down"
			sound_name = "l03x_" .. sound_suffix
		elseif voice_type == "down_stay" then
			interact_type = "cmd_down"
			if self._shout_down_t and t < self._shout_down_t + 2 then
				sound_name = "f03b_any"
			else
				sound_name = "f03a_" .. sound_suffix
			end
		elseif voice_type == "come" then
			interact_type = "cmd_come"
			local static_data = managers.criminals:character_static_data_by_unit(prime_target.unit)
			if static_data then
				local character_code = static_data.ssuffix
				sound_name = "f21" .. character_code .. "_sin"
			elseif vr_character == 'old_hoxton' then
				if mercurius then
				local la_mer = math.random(1, 1000)
					if la_mer == 850 then
					sound_name = "f21l_sin"
					else
					sound_name = "f38_any"
					end
				end
			else
				sound_name = "f38_any"
			end
		elseif voice_type == "revive" then
			interact_type = "cmd_get_up"
			local static_data = managers.criminals:character_static_data_by_unit(prime_target.unit)
			if not static_data then
				return
			end
			local character_code = static_data.ssuffix
			local revive_table = { "f36x_any", "g13" }
			local revive_random = revive_table[math.random( #revive_table )]
			if vr_character == 'american' or vr_character == 'spanish' then
			sound_name = revive_random
			else
			sound_name = "f36x_any"
			end
			if math.random() < self._ext_movement:rally_skill_data().revive_chance then
				prime_target.unit:interaction():interact(self._unit)
			end
			self._ext_movement:rally_skill_data().morale_boost_delay_t = managers.player:player_timer():time() + (self._ext_movement:rally_skill_data().morale_boost_cooldown_t or 3.5)
		elseif voice_type == "boost" then
			interact_type = "cmd_gogo"
			local static_data = managers.criminals:character_static_data_by_unit(prime_target.unit)
			if not static_data then
				return
			end
			local character_code = static_data.ssuffix
			local move_table = { "g09", "g18", "f40_any" }
			local move_random = move_table[math.random( #move_table )]
			sound_name = move_random
			self._ext_movement:rally_skill_data().morale_boost_delay_t = managers.player:player_timer():time() + (self._ext_movement:rally_skill_data().morale_boost_cooldown_t or 3.5)
		elseif voice_type == "escort" then
			interact_type = "cmd_point"
			sound_name = "e01x_" .. sound_suffix
		elseif voice_type == "escort_keep" then
			interact_type = "cmd_point"
			sound_name = "e05x_" .. sound_suffix
		elseif voice_type == "escort_go" then
			interact_type = "cmd_point"
			sound_name = "f40_any"
		elseif voice_type == "bridge_codeword" then
			sound_name = "bri_14"
			interact_type = "cmd_point"
		elseif voice_type == "bridge_chair" then
			sound_name = "bri_29"
			interact_type = "cmd_point"
		elseif voice_type == "undercover_interrogate" then
			sound_name = "und_18"
			interact_type = "cmd_point"
		elseif voice_type == "manager_spot" then
			sound_name = "f37_any"
			interact_type = "cmd_point"
		elseif voice_type == "mark_camera" then
			--sound_name = "quiet"
			interact_type = "cmd_point"
			if ply_cams then
			if vr_character == 'american' then
			sound_name = cameras_random
			elseif (vr_character == 'old_hoxton') or (vr_character == 'female_1') or (vr_character == 'jowi') then
			sound_name = "f39_any"
			else
			sound_name = cameras_random
			end
			else
			sound_name = "f39_any"
			end
			prime_target.unit:contour():add("mark_unit", true)
			DelayedCalls:Add("bain_c_all", 1, vr_c_first)
		end
		self:_do_action_intimidate(t, interact_type, sound_name, skip_alert)
	end
end

function PlayerStandard:_do_action_intimidate(t, interact_type, sound_name, skip_alert)
	if sound_name then
		self._intimidate_t = t
		if ( sound_name == "f03a_plu" ) or ( sound_name == "f03a_sin" ) then
		managers.player:local_player():sound_source():set_switch("int_ext", "third")
		self:say_line(sound_name, skip_alert)
		managers.player:local_player():sound_source():set_switch("int_ext", "first")
		else
		self:say_line(sound_name, skip_alert)
		end
		if interact_type then
			self:_play_distance_interact_redirect(t, interact_type)
		end
	end
end

elseif RequiredScript == 'lib/units/beings/player/states/playermaskoff' then

function PlayerMaskOff:mark_units(line, t, no_gesture, skip_alert)
local vr_character = managers.criminals:local_character_name()
local cameras_table = { 'f39_any', 'g25' }
local cameras_random = cameras_table[math.random( #cameras_table )]
	local mark_sec_camera = managers.player:has_category_upgrade("player", "sec_camera_highlight_mask_off")
	local mark_special_enemies = managers.player:has_category_upgrade("player", "special_enemy_highlight_mask_off")
	local voice_type, plural, prime_target = self:_get_unit_intimidation_action(mark_special_enemies, false, false, false, false)
	local interact_type, sound_name
	if voice_type == "mark_cop" or voice_type == "mark_cop_quiet" then
		interact_type = "no_gesture"
		if voice_type == "mark_cop_quiet" then
		local mark_table = { "g15", "g10" }
		local mark_random = mark_table[math.random( #mark_table )]
		local mark_old = tweak_data.character[prime_target.unit:base()._tweak_table].silent_priority_shout .. '_any'
		local mark_table_2 = { "g15", "g10", mark_old }
		local mark_random_2 = mark_table_2[math.random( #mark_table_2 )]
			if vr_character == 'american' then
				sound_name = mark_random
				elseif (vr_character == 'old_hoxton') or (vr_character == 'female 1') then
				sound_name = tweak_data.character[prime_target.unit:base()._tweak_table].silent_priority_shout .. '_any'
				else
				sound_name = mark_random_2
			end
		else
			sound_name = tweak_data.character[prime_target.unit:base()._tweak_table].priority_shout .. "x_any"
		end
		if managers.player:has_category_upgrade("player", "special_enemy_highlight") then
			prime_target.unit:contour():add(managers.player:has_category_upgrade("player", "marked_enemy_extra_damage") and "mark_enemy_damage_bonus" or "mark_enemy", true, managers.player:upgrade_value("player", "mark_enemy_time_multiplier", 1))
		end
	elseif voice_type == "mark_camera" and mark_sec_camera then
		sound_name = "f39_any"
		interact_type = "no_gesture"
		if ply_cams then
		if vr_character == 'american' then
		sound_name = cameras_random
		elseif (vr_character == 'old_hoxton') or (vr_character == 'female_1') or (vr_character == 'jowi') then
		sound_name = "f39_any"
		else
		sound_name = cameras_random
		end
		else
		sound_name = "f39_any"
		end
		prime_target.unit:contour():add("mark_unit", true)
		DelayedCalls:Add("bain_c_all", 1, vr_c_first)
	end
	if interact_type then
		if not no_gesture then
		else
		end
		self:_do_action_intimidate(t, interact_type or nil, sound_name, skip_alert)
		return true
	end
	return mark_sec_camera or mark_special_enemies
end

--Flashbangs
elseif RequiredScript == 'lib/units/beings/player/playerdamage' then

function PlayerDamage:on_flashbanged(sound_eff_mul)
	if self._downed_timer then
		return
	end
	self:_start_tinnitus(sound_eff_mul)
	if not vr_flashbang_check then
		if Utils:IsInCustody() ~= true then
		DelayedCalls:Add("flashbang_alert_team", 0.5, vr_flashbang_alert)
		DelayedCalls:Add("flashbang_alert_nullperiod", 10, vr_flashbang_check_2)
		vr_flashbang_check = true
		end
	end
end

function PlayerDamage:grenade_on_flashbanged(sound_eff_mul)
	if self._downed_timer then
		return
	end
	self:_start_tinnitus(sound_eff_mul)
end


function PlayerDamage:_check_bleed_out(can_activate_berserker)
	if self:get_real_health() == 0 and not self._check_berserker_done then
		if self._unit:movement():zipline_unit() then
			self._bleed_out_blocked_by_zipline = true
			return
		end
		if can_activate_berserker and not self._check_berserker_done then
			local has_berserker_skill = managers.player:has_category_upgrade("temporary", "berserker_damage_multiplier")
			if has_berserker_skill then
				managers.hud:set_teammate_condition(HUDManager.PLAYER_PANEL, "mugshot_swansong", managers.localization:text("debug_mugshot_downed"))
				managers.player:activate_temporary_upgrade("temporary", "berserker_damage_multiplier")
				self._check_berserker_done = true
			end
		end
		self._hurt_value = 0.2
		managers.environment_controller:set_downed_value(0)
		SoundDevice:set_rtpc("downed_state_progression", 0)
		if not self._check_berserker_done or not can_activate_berserker then
			self._revives = Application:digest_value(Application:digest_value(self._revives, false) - 1, true)
			self._check_berserker_done = nil
			managers.environment_controller:set_last_life(Application:digest_value(self._revives, false) <= 1)
			if Application:digest_value(self._revives, false) == 0 then
				self._down_time = 0
			end
			self._bleed_out = true
			managers.player:set_player_state("bleed_out")
			self._critical_state_heart_loop_instance = self._unit:sound():play("critical_state_heart_loop")
			self._slomo_sound_instance = self._unit:sound():play("downed_slomo_fx")
			self._bleed_out_health = Application:digest_value(tweak_data.player.damage.BLEED_OUT_HEALTH_INIT * managers.player:upgrade_value("player", "bleed_out_health_multiplier", 1), true)
			if managers.player:has_category_upgrade("temporary", "pistol_revive_from_bleed_out") then
				local upgrade_value = managers.player:upgrade_value("temporary", "pistol_revive_from_bleed_out")
				if upgrade_value == 0 then
				else
					local time = upgrade_value[2]
					managers.player:activate_temporary_upgrade("temporary", "pistol_revive_from_bleed_out")
				end
			end
			self:_drop_blood_sample()
			self:on_downed()
		end
	elseif (not self._said_hurt or not vr_said_hurt) and 0.2 > self:get_real_health() / self:_max_health() then
		self._said_hurt = true
		vr_said_hurt = true
		DelayedCalls:Add("said_hurt_reset", 30, said_hurt)
		PlayerStandard.say_line(self, "g80x_plu")
	end
end

function PlayerDamage:pause_downed_timer(timer)
	self._downed_paused_counter = self._downed_paused_counter + 1
	if self._downed_paused_counter == 1 then
		managers.hud:pd_pause_timer()
		managers.hud:pd_start_progress(0, timer or tweak_data.interaction.revive.timer, "debug_interact_being_revived", "interaction_help")
		if not vr_fixmeup then
		managers.player:local_player():sound_source():set_switch("int_ext", "third")
			managers.player:local_player():sound():say( "s05a_sin", true, true )
		managers.player:local_player():sound_source():set_switch("int_ext", "first")
		vr_fixmeup = true
		DelayedCalls:Add("fixmeup", tweak_data.interaction.revive.timer, r_fixmeup)
		end
	end
end

function PlayerDamage:revive(helped_self)
	if Application:digest_value(self._revives, false) == 0 then
		self._revive_health_multiplier = nil
		return
	end
	local arrested = self:arrested()
	managers.player:set_player_state("standard")
	if not helped_self then
		PlayerStandard.say_line(self, "s05x_sin")
	end
	self._bleed_out = false
	self._incapacitated = nil
	self._downed_timer = nil
	self._downed_start_time = nil
	if not arrested then
		self:set_health(self:_max_health() * tweak_data.player.damage.REVIVE_HEALTH_STEPS[self._revive_health_i] * (self._revive_health_multiplier or 1))
		self:set_armor(self:_total_armor())
		self._revive_health_i = math.min(#tweak_data.player.damage.REVIVE_HEALTH_STEPS, self._revive_health_i + 1)
		self._revive_miss = 2
	end
	self:_regenerate_armor()
	managers.hud:set_player_health({
		current = self:get_real_health(),
		total = self:_max_health(),
		revives = Application:digest_value(self._revives, false)
	})
	self:_send_set_health()
	self:_set_health_effect()
	managers.hud:pd_stop_progress()
	self._revive_health_multiplier = nil
	DelayedCalls:Remove("fixmeup")
	vr_fixmeup = nil
end

elseif RequiredScript == 'lib/units/beings/player/states/playerbleedout' then

function PlayerBleedOut:enter(state_data, enter_data)
	PlayerBleedOut.super.enter(self, state_data, enter_data)
	self._revive_SO_data = {
		unit = self._unit
	}
	self:_start_action_bleedout(managers.player:player_timer():time())
	self._tilt_wait_t = managers.player:player_timer():time() + 1
	self._old_selection = nil
	if not managers.player:has_category_upgrade("player", "primary_weapon_when_downed") and self._unit:inventory():equipped_selection() ~= 1 then
		self._old_selection = self._unit:inventory():equipped_selection()
		self:_start_action_unequip_weapon(managers.player:player_timer():time(), {selection_wanted = 1})
		self._unit:inventory():unit_by_selection(1):base():on_reload()
	end
	self._unit:camera():play_shaker("player_bleedout_land")
	PlayerStandard.say_line(self, "f11e_plu")
	local effect_id_world = "world_downed_Peer" .. tostring(managers.network:session():local_peer():id())
	managers.time_speed:play_effect(effect_id_world, tweak_data.timespeed.downed)
	local effect_id_player = "player_downed_Peer" .. tostring(managers.network:session():local_peer():id())
	managers.time_speed:play_effect(effect_id_player, tweak_data.timespeed.downed_player)
	managers.groupai:state():on_criminal_disabled(self._unit)
	if Network:is_server() and self._ext_movement:nav_tracker() then
		self._register_revive_SO(self._revive_SO_data, "revive")
	end
	if self._state_data.in_steelsight then
		self:_interupt_action_steelsight(managers.player:player_timer():time())
	end
	self:_interupt_action_melee(managers.player:player_timer():time())
	self:_interupt_action_ladder(managers.player:player_timer():time())
	managers.groupai:state():report_criminal_downed(self._unit)
	managers.network:session():send_to_peers_synched("sync_contour_state", self._unit, -1, table.index_of(ContourExt.indexed_types, "teammate_downed"), true, 1)
end

elseif RequiredScript == 'lib/managers/explosionmanager' then

function ExplosionManager:player_feedback(position, normal, range, custom_params)
	local player = managers.player:player_unit()
	if player then
		local range = custom_params and custom_params.feedback_range or range
		local feedback = managers.feedback:create("mission_triggered")
		local distance = mvector3.distance_sq(position, player:position())
		local mul = math.clamp(1 - distance / (range * range), 0, 1)
		local camera_shake_mul = custom_params and custom_params.camera_shake_mul or mul * (custom_params and custom_params.camera_shake_max_mul or 1)
		feedback:set_unit(player)
		feedback:set_enabled("camera_shake", true)
		feedback:set_enabled("rumble", true)
		feedback:set_enabled("above_camera_effect", false)
		local params = {
			"camera_shake",
			"multiplier",
			camera_shake_mul,
			"camera_shake",
			"amplitude",
			0.5,
			"camera_shake",
			"attack",
			0.05,
			"camera_shake",
			"sustain",
			0.15,
			"camera_shake",
			"decay",
			0.5,
			"rumble",
			"multiplier_data",
			mul,
			"rumble",
			"peak",
			0.5,
			"rumble",
			"attack",
			0.05,
			"rumble",
			"sustain",
			0.15,
			"rumble",
			"release",
			0.5
		}
		feedback:play(unpack(params))
		if custom_params and custom_params.sound_muffle_effect then
			local sound_eff_range = range / 4
			local sound_eff_mul = math.clamp(1 - distance / (sound_eff_range * sound_eff_range), 0, 1)
			if sound_eff_mul >= 0.3 then
				player:character_damage():grenade_on_flashbanged(sound_eff_mul)
			end
		end
	end
end

-- Gotta release that hostage
elseif RequiredScript == 'lib/managers/trademanager' then
function TradeManager:sync_hostage_trade_dialog(i)
	if game_state_machine:current_state_name() == "ingame_waiting_for_respawn" or not managers.groupai:state():bain_state() then
		return
	end
	if i == 1 then
		self:_get_megaphone_sound_source():post_event("mga_t01a_con_plu")
	elseif i == 2 then
		managers.dialog:queue_dialog("ban_h02a", {})
		DelayedCalls:Add("trade_reminder_player", 5, vr_trade_potential)
	elseif i == 3 then
		managers.dialog:queue_dialog("ban_h02b", {})
		DelayedCalls:Add("trade_reminder_player", 5, vr_trade_potential)
	elseif i == 4 then
		managers.dialog:queue_dialog("ban_h02c", {})
		DelayedCalls:Add("trade_reminder_player", 5, vr_trade_potential)
	elseif i == 5 then
		managers.dialog:queue_dialog("ban_h02d", {})
		DelayedCalls:Add("trade_reminder_player", 5, vr_trade_potential)
	elseif i == 6 then
		managers.dialog:queue_dialog("Play_ban_h50x", {})
	elseif i == 7 then
		managers.dialog:queue_dialog("Play_ban_h02", {})
		DelayedCalls:Add("trade_reminder_player", 5, vr_trade_potential)
	end
end

--Point of No Return
elseif RequiredScript == 'lib/managers/hudmanagerpd2' then
local thirtyseconds_warning

function HUDManager:show_point_of_no_return_timer()
	self._hud_assault_corner:show_point_of_no_return_timer()
	if ( Utils:IsInCustody() == false ) or not Utils:IsInCustody() then
	local current_map = managers.job:current_level_id()
	local noreturn = noreturn or function()
	local returnsuccess, returnfailure = pcall(function()
		managers.player:local_player():sound():say( 'g69', false, false )
		DelayedCalls:Add("noreturn_timetogo", 8, vr_noreturn_delay)
		DelayedCalls:Add("noreturn_fifteen", 15, vr_noreturn_fifteen)
		DelayedCalls:Add("noreturn_thirty", 30, vr_noreturn_thirty)
		DelayedCalls:Add("noreturn_fortyfive", 45, vr_noreturn_45)
		DelayedCalls:Add("noreturn_dealsealer", 55, vr_noreturn_55)
	end)
	if not returnsuccess then
		DelayedCalls:Remove("noreturn_timetogo")
		DelayedCalls:Remove("noreturn_fifteen")
		DelayedCalls:Remove("noreturn_thirty")
		DelayedCalls:Remove("noreturn_fortyfive")
		DelayedCalls:Remove("noreturn_dealsealer")
	end
	end
		if current_map == "kosugi" then
			noreturn()
		end
	end
end

elseif RequiredScript == 'lib/units/props/drill' then

function Drill:_drill_remind_clbk()
	if not self.is_hacking_device then
		local suffix = Drill.active_drills > 1 --[[and "plu"]] or "sin"
		if 1 >= self._jammed_count then
			if (Utils:IsInCustody() ~= true) and (vr_character == "german") then
			managers.player:local_player():sound():say( "d01x_sin", false, false )
			elseif (Utils:IsInCustody() ~= true) then
			managers.player:local_player():sound():say( drill_1r .. "sin", false, false )
			end
		else
			if (Utils:IsInCustody() ~= true) and (vr_character == "german") then
			managers.player:local_player():sound():say( "d02x_sin", false, false )
			elseif (Utils:IsInCustody() ~= true) then
			managers.player:local_player():sound():say( drill_2r .. "sin", false, false )
			end
		end
	elseif managers.groupai:state():bain_state() then
	end
	managers.enemy:add_delayed_clbk(Drill._drill_remind_clbk_id, Drill._drll_remind_clbk, Application:time() + 30)
	if not Utils:IsInGameState() then
	if DLCManager_hasdlcpack(hoxton_traitor) and server_synchronised then
		mercurius_exec()
	end
	end
end

elseif RequiredScript == 'lib/managers/hud/hudsuspicion' then
local discovered = 0
function HUDSuspicion:discovered()
local vr_fuck = { 'g60', 'g29' }
	self._discovered = true
	if not stopforabitv then
	managers.player:local_player():sound():say( vr_fuck[math.random( #vr_fuck )], false, true )
	end
	discovered = discovered + 1
	if discovered > 3 then
		DelayedCalls:Add("stopforabit", 10, stopforabit)
	end
end

end